Index: source/gui/scripting/JSInterface_IGUIObject.cpp
===================================================================
--- source/gui/scripting/JSInterface_IGUIObject.cpp	(Revision 14578)
+++ source/gui/scripting/JSInterface_IGUIObject.cpp	(Arbeitskopie)
@@ -32,28 +32,28 @@
 
 JSClass JSI_IGUIObject::JSI_class = {
 	"GUIObject", JSCLASS_HAS_PRIVATE,
-	JS_PropertyStub, JS_PropertyStub,
+	JS_PropertyStub, JS_DeletePropertyStub,
 	JSI_IGUIObject::getProperty, JSI_IGUIObject::setProperty,
 	JS_EnumerateStub, JS_ResolveStub,
-	JS_ConvertStub, JS_FinalizeStub,
+	JS_ConvertStub, NULL,
 	NULL, NULL, NULL, JSI_IGUIObject::construct
 };
 
-JSPropertySpec JSI_IGUIObject::JSI_props[] = 
+JSPropertySpec JSI_IGUIObject::JSI_props[] =
 {
 	{ 0 }
 };
 
-JSFunctionSpec JSI_IGUIObject::JSI_methods[] = 
+JSFunctionSpec JSI_IGUIObject::JSI_methods[] =
 {
-	{ "toString", JSI_IGUIObject::toString, 0, 0 },
-	{ "focus", JSI_IGUIObject::focus, 0, 0 },
-	{ "blur", JSI_IGUIObject::blur, 0, 0 },
-	{ "getComputedSize", JSI_IGUIObject::getComputedSize, 0, 0 },
-	{ 0 }
+	JS_FS("toString", JSI_IGUIObject::toString, 0, 0),
+	JS_FS("focus", JSI_IGUIObject::focus, 0, 0),
+	JS_FS("blur", JSI_IGUIObject::blur, 0, 0),
+	JS_FS("getComputedSize", JSI_IGUIObject::getComputedSize, 0, 0),
+	JS_FS_END
 };
 
-JSBool JSI_IGUIObject::getProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp)
+JSBool JSI_IGUIObject::getProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::MutableHandle<jsval> vp)
 {
 	IGUIObject* e = (IGUIObject*)JS_GetInstancePrivate(cx, obj, &JSI_IGUIObject::JSI_class, NULL);
 	if (!e)
@@ -88,9 +88,9 @@
 		CStr eventName (CStr(propName.substr(2)).LowerCase());
 		std::map<CStr, CScriptValRooted>::iterator it = e->m_ScriptHandlers.find(eventName);
 		if (it == e->m_ScriptHandlers.end())
-			*vp = JSVAL_NULL;
+			vp.set(JSVAL_NULL);
 		else
-			*vp = it->second.get();
+			vp.set((*it).second.get());
 		return JS_TRUE;
 	}
 
@@ -102,19 +102,19 @@
 		if (parent)
 		{
 			// If the object isn't parentless, return a new object
-			*vp = OBJECT_TO_JSVAL(parent->GetJSObject());
+			vp.set(OBJECT_TO_JSVAL(parent->GetJSObject()));
 		}
 		else
 		{
 			// Return null if there's no parent
-			*vp = JSVAL_NULL;
+			vp.set(JSVAL_NULL);
 		}
 		return JS_TRUE;
 	}
 	// Also handle "name" specially
 	else if (propName == "name")
 	{
-		*vp = STRING_TO_JSVAL(JS_NewStringCopyZ(cx, e->GetName().c_str()));
+		vp.set(STRING_TO_JSVAL(JS_NewStringCopyZ(cx, e->GetName().c_str())));
 		return JS_TRUE;
 	}
 	// Handle all other properties
@@ -135,7 +135,8 @@
 			{
 				bool value;
 				GUI<bool>::GetSetting(e, propName, value);
-				*vp = value ? JSVAL_TRUE : JSVAL_FALSE;
+				vp.set(BOOLEAN_TO_JSVAL(value));
+				//value ? JSVAL_TRUE : JSVAL_FALSE;
 				break;
 			}
 
@@ -143,7 +144,7 @@
 			{
 				int value;
 				GUI<int>::GetSetting(e, propName, value);
-				*vp = INT_TO_JSVAL(value);
+				vp.set(INT_TO_JSVAL(value));
 				break;
 			}
 
@@ -152,7 +153,8 @@
 				float value;
 				GUI<float>::GetSetting(e, propName, value);
 				// Create a garbage-collectable double
-				return JS_NewNumberValue(cx, value, vp);
+				vp.set(JS_NumberValue(value));
+				return !JSVAL_IS_NULL(vp.get());
 			}
 
 		case GUIST_CColor:
@@ -160,11 +162,12 @@
 				CColor colour;
 				GUI<CColor>::GetSetting(e, propName, colour);
 				JSObject* obj = JS_NewObject(cx, &JSI_GUIColor::JSI_class, NULL, NULL);
-				*vp = OBJECT_TO_JSVAL(obj); // root it
+				vp.set(OBJECT_TO_JSVAL(obj)); // root it
 
-				jsval c;
+				JS::RootedValue c(cx);
 				// Attempt to minimise ugliness through macrosity
-				#define P(x) if (!JS_NewNumberValue(cx, colour.x, &c)) return JS_FALSE; JS_SetProperty(cx, obj, #x, &c)
+				#define P(x) c = JS_NumberValue(colour.x); \
+				if (JSVAL_IS_NULL(c)) return false; JS_SetProperty(cx, obj, #x, c.address())
 					P(r);
 					P(g);
 					P(b);
@@ -179,7 +182,7 @@
 				CClientArea area;
 				GUI<CClientArea>::GetSetting(e, propName, area);
 				JSObject* obj = JS_NewObject(cx, &JSI_GUISize::JSI_class, NULL, NULL);
-				*vp = OBJECT_TO_JSVAL(obj); // root it
+				vp.set(OBJECT_TO_JSVAL(obj)); // root it
 				try
 				{
 					ScriptInterface* pScriptInterface = ScriptInterface::GetScriptInterfaceAndCBData(cx)->pScriptInterface;
@@ -207,7 +210,7 @@
 			{
 				CGUIString value;
 				GUI<CGUIString>::GetSetting(e, propName, value);
-				*vp = ScriptInterface::ToJSVal(cx, value.GetOriginalString());
+				vp.set(ScriptInterface::ToJSVal(cx, value.GetOriginalString()));
 				break;
 			}
 
@@ -215,7 +218,7 @@
 			{
 				CStr value;
 				GUI<CStr>::GetSetting(e, propName, value);
-				*vp = ScriptInterface::ToJSVal(cx, value);
+				vp.set(ScriptInterface::ToJSVal(cx, value));
 				break;
 			}
 
@@ -223,7 +226,7 @@
 			{
 				CStrW value;
 				GUI<CStrW>::GetSetting(e, propName, value);
-				*vp = ScriptInterface::ToJSVal(cx, value);
+				vp.set(ScriptInterface::ToJSVal(cx, value));
 				break;
 			}
 
@@ -231,7 +234,7 @@
 			{
 				CGUISpriteInstance *value;
 				GUI<CGUISpriteInstance>::GetSettingPointer(e, propName, value);
-				*vp = ScriptInterface::ToJSVal(cx, value->GetName());
+				vp.set(ScriptInterface::ToJSVal(cx, value->GetName()));
 				break;
 			}
 
@@ -247,7 +250,7 @@
 				case EAlign_Center: word = "center"; break;
 				default: debug_warn(L"Invalid EAlign!"); word = "error"; break;
 				}
-				*vp = ScriptInterface::ToJSVal(cx, word);
+				vp.set(ScriptInterface::ToJSVal(cx, word));
 				break;
 			}
 
@@ -263,7 +266,7 @@
 				case EVAlign_Center: word = "center"; break;
 				default: debug_warn(L"Invalid EVAlign!"); word = "error"; break;
 				}
-				*vp = ScriptInterface::ToJSVal(cx, word);
+				vp.set(ScriptInterface::ToJSVal(cx, word));
 				break;
 			}
 
@@ -273,12 +276,12 @@
 				GUI<CGUIList>::GetSetting(e, propName, value);
 
 				JSObject *obj = JS_NewArrayObject(cx, 0, NULL);
-				*vp = OBJECT_TO_JSVAL(obj); // root it
-				
+				vp.set(OBJECT_TO_JSVAL(obj)); // root it
+
 				for (size_t i = 0; i < value.m_Items.size(); ++i)
 				{
-					jsval val = ScriptInterface::ToJSVal(cx, value.m_Items[i].GetOriginalString());
-					JS_SetElement(cx, obj, (jsint)i, &val);
+					JS::RootedValue val(cx, ScriptInterface::ToJSVal(cx, value.m_Items[i].GetOriginalString()));
+					JS_SetElement(cx, obj, (uint32_t)i, val.address());
 				}
 
 				break;
@@ -294,7 +297,7 @@
 	}
 }
 
-JSBool JSI_IGUIObject::setProperty(JSContext* cx, JSObject* obj, jsid id, JSBool UNUSED(strict), jsval* vp)
+JSBool JSI_IGUIObject::setProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JSBool UNUSED(strict), JS::MutableHandle<jsval> vp)
 {
 	IGUIObject* e = (IGUIObject*)JS_GetInstancePrivate(cx, obj, &JSI_IGUIObject::JSI_class, NULL);
 	if (!e)
@@ -311,7 +314,7 @@
 	if (propName == "name")
 	{
 		std::string value;
-		if (!ScriptInterface::FromJSVal(cx, *vp, value))
+		if (!ScriptInterface::FromJSVal(cx, vp.get(), value))
 			return JS_FALSE;
 		e->SetName(value);
 		return JS_TRUE;
@@ -320,14 +323,14 @@
 	// Use onWhatever to set event handlers
 	if (propName.substr(0, 2) == "on")
 	{
-		if (!JSVAL_IS_OBJECT(*vp) || !JS_ObjectIsFunction(cx, JSVAL_TO_OBJECT(*vp)))
+		if (JSVAL_IS_PRIMITIVE(vp.get()) || !JS_ObjectIsFunction(cx, JSVAL_TO_OBJECT(vp.get())))
 		{
 			JS_ReportError(cx, "on- event-handlers must be functions");
 			return JS_FALSE;
 		}
 
 		CStr eventName (CStr(propName.substr(2)).LowerCase());
-		e->SetScriptHandler(eventName, JSVAL_TO_OBJECT(*vp));
+		e->SetScriptHandler(eventName, JSVAL_TO_OBJECT(vp.get()));
 
 		return JS_TRUE;
 	}
@@ -346,7 +349,7 @@
 	case GUIST_CStr:
 		{
 			std::string value;
-			if (!ScriptInterface::FromJSVal(cx, *vp, value))
+			if (!ScriptInterface::FromJSVal(cx, vp.get(), value))
 				return JS_FALSE;
 
 			GUI<CStr>::SetSetting(e, propName, value);
@@ -356,8 +359,8 @@
 	case GUIST_CStrW:
 		{
 			std::wstring value;
-			if (!ScriptInterface::FromJSVal(cx, *vp, value))
-				return JS_FALSE;
+			if (!ScriptInterface::FromJSVal(cx, vp.get(), value))
+				return false;
 
 			GUI<CStrW>::SetSetting(e, propName, value);
 			break;
@@ -366,8 +369,8 @@
 	case GUIST_CGUISpriteInstance:
 		{
 			std::string value;
-			if (!ScriptInterface::FromJSVal(cx, *vp, value))
-				return JS_FALSE;
+			if (!ScriptInterface::FromJSVal(cx, vp.get(), value))
+				return false;
 
 			GUI<CGUISpriteInstance>::SetSetting(e, propName, CGUISpriteInstance(value));
 			break;
@@ -376,7 +379,7 @@
 	case GUIST_CGUIString:
 		{
 			std::wstring value;
-			if (!ScriptInterface::FromJSVal(cx, *vp, value))
+			if (!ScriptInterface::FromJSVal(cx, vp.get(), value))
 				return JS_FALSE;
 
 			CGUIString str;
@@ -388,7 +391,7 @@
 	case GUIST_EAlign:
 		{
 			std::string value;
-			if (!ScriptInterface::FromJSVal(cx, *vp, value))
+			if (!ScriptInterface::FromJSVal(cx, vp.get(), value))
 				return JS_FALSE;
 
 			EAlign a;
@@ -407,7 +410,7 @@
 	case GUIST_EVAlign:
 		{
 			std::string value;
-			if (!ScriptInterface::FromJSVal(cx, *vp, value))
+			if (!ScriptInterface::FromJSVal(cx, vp.get(), value))
 				return JS_FALSE;
 
 			EVAlign a;
@@ -425,8 +428,8 @@
 
 	case GUIST_int:
 		{
-			int32 value;
-			if (JS_ValueToInt32(cx, *vp, &value) == JS_TRUE)
+			int32_t value;
+			if (JS_ValueToInt32(cx, vp.get(), &value) == true)
 				GUI<int>::SetSetting(e, propName, value);
 			else
 			{
@@ -438,8 +441,8 @@
 
 	case GUIST_float:
 		{
-			jsdouble value;
-			if (JS_ValueToNumber(cx, *vp, &value) == JS_TRUE)
+			double value;
+			if (JS_ValueToNumber(cx, vp.get(), &value) == true)
 				GUI<float>::SetSetting(e, propName, (float)value);
 			else
 			{
@@ -452,8 +455,8 @@
 	case GUIST_bool:
 		{
 			JSBool value;
-			if (JS_ValueToBoolean(cx, *vp, &value) == JS_TRUE)
-				GUI<bool>::SetSetting(e, propName, value == JS_TRUE);
+			if (JS_ValueToBoolean(cx, vp.get(), &value))
+				GUI<bool>::SetSetting(e, propName, value);
 			else
 			{
 				JS_ReportError(cx, "Cannot convert value to bool");
@@ -464,10 +467,10 @@
 
 	case GUIST_CClientArea:
 		{
-			if (JSVAL_IS_STRING(*vp))
+			if (JSVAL_IS_STRING(vp.get()))
 			{
 				std::wstring value;
-				if (!ScriptInterface::FromJSVal(cx, *vp, value))
+				if (!ScriptInterface::FromJSVal(cx, vp.get(), value))
 					return JS_FALSE;
 
 				if (e->SetSetting(propName, value) != PSRETURN_OK)
@@ -476,12 +479,12 @@
 					return JS_FALSE;
 				}
 			}
-			else if (JSVAL_IS_OBJECT(*vp) && JS_InstanceOf(cx, JSVAL_TO_OBJECT(*vp), &JSI_GUISize::JSI_class, NULL))
+			else if (!JSVAL_IS_PRIMITIVE(vp.get()) && JS_InstanceOf(cx, JSVAL_TO_OBJECT(vp.get()), &JSI_GUISize::JSI_class, NULL))
 			{
 				CClientArea area;
 				GUI<CClientArea>::GetSetting(e, propName, area);
 
-				JSObject* obj = JSVAL_TO_OBJECT(*vp);
+				JSObject* obj = JSVAL_TO_OBJECT(vp.get());
 				ScriptInterface* pScriptInterface = ScriptInterface::GetScriptInterfaceAndCBData(cx)->pScriptInterface;
 				#define P(x, y, z) pScriptInterface->GetProperty(OBJECT_TO_JSVAL(obj), #z, area.x.y)
 					P(pixel,	left,	left);
@@ -506,10 +509,10 @@
 
 	case GUIST_CColor:
 		{
-			if (JSVAL_IS_STRING(*vp))
+			if (JSVAL_IS_STRING(vp.get()))
 			{
 				std::wstring value;
-				if (!ScriptInterface::FromJSVal(cx, *vp, value))
+				if (!ScriptInterface::FromJSVal(cx, vp.get(), value))
 					return JS_FALSE;
 
 				if (e->SetSetting(propName, value) != PSRETURN_OK)
@@ -518,12 +521,13 @@
 					return JS_FALSE;
 				}
 			}
-			else if (JSVAL_IS_OBJECT(*vp) && JS_InstanceOf(cx, JSVAL_TO_OBJECT(*vp), &JSI_GUIColor::JSI_class, NULL))
+			else if (!JSVAL_IS_PRIMITIVE(vp.get()) && JS_InstanceOf(cx, JSVAL_TO_OBJECT(vp.get()), &JSI_GUIColor::JSI_class, NULL))
 			{
 				CColor colour;
-				JSObject* obj = JSVAL_TO_OBJECT(*vp);
-				jsval t; double s;
-				#define PROP(x) JS_GetProperty(cx, obj, #x, &t); \
+				JSObject* obj = JSVAL_TO_OBJECT(vp.get());
+				JS::RootedValue t(cx);
+				double s;
+				#define PROP(x) JS_GetProperty(cx, obj, #x, t.address()); \
 								JS_ValueToNumber(cx, t, &s); \
 								colour.x = (float)s
 				PROP(r); PROP(g); PROP(b); PROP(a);
@@ -541,16 +545,16 @@
 
 	case GUIST_CGUIList:
 		{
-			JSObject* obj = JSVAL_TO_OBJECT(*vp);
-			jsuint length;
-			if (JSVAL_IS_OBJECT(*vp) && JS_GetArrayLength(cx, obj, &length) == JS_TRUE)
+			JSObject* obj = JSVAL_TO_OBJECT(vp.get());
+			uint length;
+			if (!JSVAL_IS_PRIMITIVE(vp.get()) && JS_GetArrayLength(cx, obj, &length) == true)
 			{
 				CGUIList list;
 
 				for (int i=0; i<(int)length; ++i)
 				{
-					jsval element;
-					if (! JS_GetElement(cx, obj, i, &element))
+					JS::RootedValue element(cx);
+					if (! JS_GetElement(cx, obj, i, element.address()))
 					{
 						JS_ReportError(cx, "Failed to get list element");
 						return JS_FALSE;
@@ -562,7 +566,7 @@
 
 					CGUIString str;
 					str.SetValue(value);
-					
+
 					list.m_Items.push_back(str);
 				}
 
@@ -587,7 +591,7 @@
 }
 
 
-JSBool JSI_IGUIObject::construct(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_IGUIObject::construct(JSContext* cx, uint argc, jsval* vp)
 {
 	if (argc == 0)
 	{
@@ -599,7 +603,7 @@
 
 	// Store the IGUIObject in the JS object's 'private' area
 	IGUIObject* guiObject = (IGUIObject*)JSVAL_TO_PRIVATE(JS_ARGV(cx, vp)[0]);
-	JS_SetPrivate(cx, obj, guiObject);
+	JS_SetPrivate(obj, guiObject);
 
 	JS_SET_RVAL(cx, vp, OBJECT_TO_JSVAL(obj));
 	return JS_TRUE;
@@ -610,7 +614,7 @@
 	scriptInterface.DefineCustomObjectType(&JSI_class, construct, 1, JSI_props, JSI_methods, NULL, NULL);
 }
 
-JSBool JSI_IGUIObject::toString(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_IGUIObject::toString(JSContext* cx, uint argc, jsval* vp)
 {
 	UNUSED2(argc);
 
@@ -625,7 +629,7 @@
 	return JS_TRUE;
 }
 
-JSBool JSI_IGUIObject::focus(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_IGUIObject::focus(JSContext* cx, uint argc, jsval* vp)
 {
 	UNUSED2(argc);
 
@@ -639,7 +643,7 @@
 	return JS_TRUE;
 }
 
-JSBool JSI_IGUIObject::blur(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_IGUIObject::blur(JSContext* cx, uint argc, jsval* vp)
 {
 	UNUSED2(argc);
 
@@ -653,7 +657,7 @@
 	return JS_TRUE;
 }
 
-JSBool JSI_IGUIObject::getComputedSize(JSContext* cx, uintN argc, jsval* vp)
+JSBool JSI_IGUIObject::getComputedSize(JSContext* cx, uint argc, jsval* vp)
 {
 	UNUSED2(argc);
 	IGUIObject* e = (IGUIObject*)JS_GetInstancePrivate(cx, JS_THIS_OBJECT(cx, vp), &JSI_IGUIObject::JSI_class, NULL);
Index: source/gui/scripting/GuiScriptConversions.cpp
===================================================================
--- source/gui/scripting/GuiScriptConversions.cpp	(Revision 14578)
+++ source/gui/scripting/GuiScriptConversions.cpp	(Arbeitskopie)
@@ -23,14 +23,13 @@
 #include "lib/external_libraries/libsdl.h"
 #include "ps/Hotkey.h"
 
-#include "js/jsapi.h"
-
-#define SET(obj, name, value) STMT(jsval v_ = ToJSVal(cx, (value)); JS_SetProperty(cx, (obj), (name), &v_))
+#define SET(obj, name, value) STMT(JS::RootedValue v_(cx, ToJSVal(cx, (value))); JS_SetProperty(cx, (obj), (name), v_.address()))
 	// ignore JS_SetProperty return value, because errors should be impossible
 	// and we can't do anything useful in the case of errors anyway
 
 template<> jsval ScriptInterface::ToJSVal<SDL_Event_>(JSContext* cx, SDL_Event_ const& val)
 {
+	JSAutoRequest rq(cx);
 	const char* typeName;
 
 	switch (val.ev.type)
@@ -78,8 +77,8 @@
 		JSObject* keysym = JS_NewObject(cx, NULL, NULL, NULL);
 		if (! keysym)
 			return JSVAL_VOID;
-		jsval keysymVal = OBJECT_TO_JSVAL(keysym);
-		JS_SetProperty(cx, obj, "keysym", &keysymVal);
+		JS::RootedValue keysymVal(cx, OBJECT_TO_JSVAL(keysym));
+		JS_SetProperty(cx, obj, "keysym", keysymVal.address());
 
 		// SET(keysym, "scancode", (int)val.ev.key.keysym.scancode); // (not in wsdl.h)
 		SET(keysym, "sym", (int)val.ev.key.keysym.sym);
Index: source/gui/scripting/JSInterface_IGUIObject.h
===================================================================
--- source/gui/scripting/JSInterface_IGUIObject.h	(Revision 14578)
+++ source/gui/scripting/JSInterface_IGUIObject.h	(Arbeitskopie)
@@ -25,13 +25,13 @@
 	extern JSClass JSI_class;
 	extern JSPropertySpec JSI_props[];
 	extern JSFunctionSpec JSI_methods[];
-	JSBool getProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp);
-	JSBool setProperty(JSContext* cx, JSObject* obj, jsid id, JSBool strict, jsval* vp);
-	JSBool construct(JSContext* cx, uintN argc, jsval* vp);
-	JSBool toString(JSContext* cx, uintN argc, jsval* vp);
-	JSBool focus(JSContext* cx, uintN argc, jsval* vp);
-	JSBool blur(JSContext* cx, uintN argc, jsval* vp);
-	JSBool getComputedSize(JSContext* cx, uintN argc, jsval* vp);
+	JSBool getProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::MutableHandle<jsval> vp);
+	JSBool setProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JSBool UNUSED(strict), JS::MutableHandle<jsval> vp);
+	JSBool construct(JSContext* cx, uint argc, jsval* vp);
+	JSBool toString(JSContext* cx, uint argc, jsval* vp);
+	JSBool focus(JSContext* cx, uint argc, jsval* vp);
+	JSBool blur(JSContext* cx, uint argc, jsval* vp);
+	JSBool getComputedSize(JSContext* cx, uint argc, jsval* vp);
 	void init(ScriptInterface& scriptInterface);
 }
 
Index: source/gui/IGUIObject.h
===================================================================
--- source/gui/IGUIObject.h	(Revision 14578)
+++ source/gui/IGUIObject.h	(Arbeitskopie)
@@ -142,9 +142,9 @@
 	friend class GUITooltip;
 
 	// Allow getProperty to access things like GetParent()
-	friend JSBool JSI_IGUIObject::getProperty(JSContext* cx, JSObject* obj, jsid id, jsval* vp);
-	friend JSBool JSI_IGUIObject::setProperty(JSContext* cx, JSObject* obj, jsid id, JSBool strict, jsval* vp);
-	friend JSBool JSI_IGUIObject::getComputedSize(JSContext* cx, uintN argc, jsval* vp);
+	friend JSBool JSI_IGUIObject::getProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JS::MutableHandle<jsval> vp);
+	friend JSBool JSI_IGUIObject::setProperty(JSContext* cx, JS::Handle<JSObject*> obj, JS::Handle<jsid> id, JSBool UNUSED(strict), JS::MutableHandle<jsval> vp);
+	friend JSBool JSI_IGUIObject::getComputedSize(JSContext* cx, uint argc, jsval* vp);
 
 public:
 	IGUIObject();
Index: libraries/source/spidermonkey/build.sh
===================================================================
--- libraries/source/spidermonkey/build.sh	(Revision 14578)
+++ libraries/source/spidermonkey/build.sh	(Arbeitskopie)
@@ -17,14 +17,15 @@
 echo "Building SpiderMonkey..."
 echo
 
-JOBS=${JOBS:="-j2"}
+
+JOBS=${JOBS:="-j5"}
 MAKE=${MAKE:="make"}
 
 MAKE_OPTS="${JOBS}"
+NSPR_INCLUDES="`pkg-config nspr --cflags`"
+NSPR_LIBS="`pkg-config nspr --libs`"
 
-CONF_OPTS="--disable-tests"
-# (We don't use --enable-threadsafe because we don't use a single runtime in
-# multiple threads, so it is unnecessary complexity and performance overhead)
+CONF_OPTS="--disable-e4x --enable-threadsafe --enable-shared-js --disable-tests" # --enable-trace-logging"
 
 # If Valgrind looks like it's installed, then set up SM to support it
 # (else the JITs will interact poorly with it)
@@ -33,9 +34,6 @@
   CONF_OPTS="${CONF_OPTS} --enable-valgrind"
 fi
 
-#CONF_OPTS="${CONF_OPTS} --enable-threadsafe --with-system-nspr"
-#CONF_OPTS="${CONF_OPTS} --enable-trace-jscalls"
-
 # We need to be able to override CHOST in case it is 32bit userland on 64bit kernel
 CONF_OPTS="${CONF_OPTS} \
   ${CBUILD:+--build=${CBUILD}} \
@@ -43,42 +41,44 @@
   ${CTARGET:+--target=${CTARGET}}"
 
 echo "SpiderMonkey build options: ${CONF_OPTS}"
+echo ${CONF_OPTS}
 
-# Extract the tarball
-tar xzf js185-1.0.0.tar.gz
+# Delete the existing directory to avoid conflicts and extract the tarball
+rm -rf mozjs24
+tar xjf mozjs-24.2.0.tar.bz2
 
-# Apply patches
-patch -p0 < openbsd-spidermonkey-650742.diff
-patch -p0 < openbsd-spidermonkey-634609.diff
+# Apply patches if needed
+#patch -p0 < name_of_thepatch.diff
 
-cd js-1.8.5/js/src
+# rename the extracted directory to something shorter
+mv mozjs-24.2.0 mozjs24
 
+cd mozjs24/js/src
+
 # We want separate debug/release versions of the library, so we have to change
 # the LIBRARY_NAME for each build.
 # (We use perl instead of sed so that it works with MozillaBuild on Windows,
 # which has an ancient sed.)
-perl -i.bak -pe 's/^(LIBRARY_NAME\s+= mozjs185)(-ps-debug|-ps-release)?/$1-ps-debug/' Makefile.in
+perl -i.bak -pe 's/(^LIBRARY_NAME\s+=).*/$1mozjs24-ps-debug/' Makefile.in
 mkdir -p build-debug
 cd build-debug
-../configure ${CONF_OPTS} --enable-debug --disable-optimize
+../configure ${CONF_OPTS} --with-nspr-libs="$NSPR_LIBS" --with-nspr-cflags="$NSPR_INCLUDES" --enable-debug --disable-optimize --enable-js-diagnostics --enable-gczeal # --enable-root-analysis
 ${MAKE} ${MAKE_OPTS}
 cd ..
 
-perl -i.bak -pe 's/^(LIBRARY_NAME\s+= mozjs185)(-ps-debug|-ps-release)?/$1-ps-release/' Makefile.in
+perl -i.bak -pe 's/(^LIBRARY_NAME\s+=).*/$1mozjs24-ps-release/' Makefile.in
 mkdir -p build-release
 cd build-release
-../configure ${CONF_OPTS} # --enable-gczeal --enable-debug-symbols
+../configure ${CONF_OPTS} --with-nspr-libs="$NSPR_LIBS" --with-nspr-cflags="$NSPR_INCLUDES" --enable-optimize  # --enable-gczeal --enable-debug-symbols
 ${MAKE} ${MAKE_OPTS}
 cd ..
 
-# Remove the library suffixes to avoid spurious SVN diffs
-perl -i.bak -pe 's/^(LIBRARY_NAME\s+= mozjs185)(-ps-debug|-ps-release)?/$1/' Makefile.in
-
 cd ../../..
 
 if [ "${OS}" = "Windows_NT" ]
 then
-  INCLUDE_DIR=include-win32
+  INCLUDE_DIR_DEBUG=include-win32-debug
+  INCLUDE_DIR_RELEASE=include-win32-release
   DLL_SRC_SUFFIX=-1.0.dll
   DLL_DST_SUFFIX=-1.0.dll
   LIB_PREFIX=
@@ -86,19 +86,21 @@
   LIB_DST_SUFFIX=.lib
 elif [ "`uname -s`" = "Darwin" ]
 then
-  INCLUDE_DIR=include-unix
+  INCLUDE_DIR_DEBUG=include-unix-debug
+  INCLUDE_DIR_RELEASE=include-unix-release
   DLL_SRC_SUFFIX=.dylib
   DLL_DST_SUFFIX=.1.0.dylib
   LIB_PREFIX=lib
   LIB_SRC_SUFFIX=.dylib
   LIB_DST_SUFFIX=.dylib
   # Fix libtool's use of an absolute path
-  install_name_tool -id @executable_path/${LIB_PREFIX}mozjs185-ps-debug${DLL_DST_SUFFIX} js-1.8.5/js/src/build-debug/dist/bin/${LIB_PREFIX}mozjs185-ps-debug${DLL_SRC_SUFFIX}
-  install_name_tool -id @executable_path/${LIB_PREFIX}mozjs185-ps-release${DLL_DST_SUFFIX} js-1.8.5/js/src/build-release/dist/bin/${LIB_PREFIX}mozjs185-ps-release${DLL_SRC_SUFFIX}
+  install_name_tool -id @executable_path/${LIB_PREFIX}mozjs24-ps-debug${DLL_DST_SUFFIX} mozjs24/js/src/build-debug/dist/bin/${LIB_PREFIX}mozjs24-ps-debug${DLL_SRC_SUFFIX}
+  install_name_tool -id @executable_path/${LIB_PREFIX}mozjs24-ps-release${DLL_DST_SUFFIX} mozjs24/js/src/build-release/dist/bin/${LIB_PREFIX}mozjs24-ps-release${DLL_SRC_SUFFIX}
 else
-  INCLUDE_DIR=include-unix
+  INCLUDE_DIR_DEBUG=include-unix-debug
+  INCLUDE_DIR_RELEASE=include-unix-release
   DLL_SRC_SUFFIX=.so
-  DLL_DST_SUFFIX=.so.1.0
+  DLL_DST_SUFFIX=.so
   LIB_PREFIX=lib
   LIB_SRC_SUFFIX=.so
   LIB_DST_SUFFIX=.so
@@ -113,15 +115,17 @@
 
 # Copy files into the necessary locations for building and running the game
 
-# js-config.h is the same for both debug and release builds, so we only need to copy one
-mkdir -p ${INCLUDE_DIR}/js
-cp -L js-1.8.5/js/src/build-release/dist/include/* ${INCLUDE_DIR}/js/
+# js-config.h is different for debug and release builds, so we need different include directories for both
+mkdir -p ${INCLUDE_DIR_DEBUG}
+mkdir -p ${INCLUDE_DIR_RELEASE}
+cp -R -L mozjs24/js/src/build-release/dist/include/* ${INCLUDE_DIR_RELEASE}/
+cp -R -L mozjs24/js/src/build-debug/dist/include/* ${INCLUDE_DIR_DEBUG}/
 
 mkdir -p lib/
-cp -L js-1.8.5/js/src/build-debug/dist/lib/${LIB_PREFIX}mozjs185-ps-debug${LIB_SRC_SUFFIX} lib/${LIB_PREFIX}mozjs185-ps-debug${LIB_DST_SUFFIX}
-cp -L js-1.8.5/js/src/build-release/dist/lib/${LIB_PREFIX}mozjs185-ps-release${LIB_SRC_SUFFIX} lib/${LIB_PREFIX}mozjs185-ps-release${LIB_DST_SUFFIX}
-cp -L js-1.8.5/js/src/build-debug/dist/bin/${LIB_PREFIX}mozjs185-ps-debug${DLL_SRC_SUFFIX} ../../../binaries/system/${LIB_PREFIX}mozjs185-ps-debug${DLL_DST_SUFFIX}
-cp -L js-1.8.5/js/src/build-release/dist/bin/${LIB_PREFIX}mozjs185-ps-release${DLL_SRC_SUFFIX} ../../../binaries/system/${LIB_PREFIX}mozjs185-ps-release${DLL_DST_SUFFIX}
+cp -L mozjs24/js/src/build-debug/dist/lib/${LIB_PREFIX}mozjs24-ps-debug${LIB_SRC_SUFFIX} lib/${LIB_PREFIX}mozjs24-ps-debug${LIB_DST_SUFFIX}
+cp -L mozjs24/js/src/build-release/dist/lib/${LIB_PREFIX}mozjs24-ps-release${LIB_SRC_SUFFIX} lib/${LIB_PREFIX}mozjs24-ps-release${LIB_DST_SUFFIX}
+cp -L mozjs24/js/src/build-debug/dist/bin/${LIB_PREFIX}mozjs24-ps-debug${DLL_SRC_SUFFIX} ../../../binaries/system/${LIB_PREFIX}mozjs24-ps-debug${DLL_DST_SUFFIX}
+cp -L mozjs24/js/src/build-release/dist/bin/${LIB_PREFIX}mozjs24-ps-release${DLL_SRC_SUFFIX} ../../../binaries/system/${LIB_PREFIX}mozjs24-ps-release${DLL_DST_SUFFIX}
 
 # Flag that it's already been built successfully so we can skip it next time
 touch .already-built
